// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/driver/16sdi.h $
// $Rev: 51954 $
// $Date: 2022-10-25 08:44:06 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Device Driver: header file

#ifndef	__16SDI_H__
#define	__16SDI_H__

#include "gsc_common.h"
#include "gsc_pci9080.h"



// macros *********************************************************************

#define	SDI_BASE_NAME						"16sdi"

#define	SDI_FGEN_FACTOR_BASIC				(8000./511)
#define	SDI_FGEN_BASIC_KHZ(nrate)			(SDI_FGEN_FACTOR_BASIC * ((nrate) + 511))
#define	SDI_FSAMP_BASIC_KSPS(nrate,ndiv)	(SDI_FGEN_BASIC_KHZ(nrate) / (64L * (ndiv)))

#define	SDI_FGEN_FACTOR_HS					(19.2/511)
#define	SDI_FGEN_HS_MHZ(nrate)				(19.2 + (SDI_FGEN_FACTOR_HS * (nrate)))
#define	SDI_DIVISOR_HS(ndiv)				((ndiv) ? (ndiv) : 0.5)
#define	SDI_FSAMP_HS_MSPS(nrate,ndiv)		(SDI_FGEN_HS_MHZ(nrate) / (64.0 * SDI_DIVISOR_HS(ndiv)))

// IOCTL command codes
#define	SDI_IOCTL_REG_READ					OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	SDI_IOCTL_REG_WRITE					OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	SDI_IOCTL_REG_MOD					OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	SDI_IOCTL_QUERY						OS_IOCTL_RW( 3,  4, s32)
#define	SDI_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define	SDI_IOCTL_AUTO_CALIBRATE			OS_IOCTL   ( 5)
#define	SDI_IOCTL_RX_IO_MODE				OS_IOCTL_RW( 6,  4, s32)
#define	SDI_IOCTL_RX_IO_TIMEOUT				OS_IOCTL_RW( 7,  4, s32)
#define	SDI_IOCTL_AIN_BUF_CLEAR				OS_IOCTL   ( 8)
#define	SDI_IOCTL_AIN_BUF_INPUT				OS_IOCTL_RW( 9,  4, s32)
#define	SDI_IOCTL_AIN_BUF_THRESH			OS_IOCTL_RW(10,  4, s32)
#define	SDI_IOCTL_AIN_MODE					OS_IOCTL_RW(11,  4, s32)
#define	SDI_IOCTL_AIN_RANGE					OS_IOCTL_RW(12,  4, s32)
#define	SDI_IOCTL_CH_GRP_0_SRC				OS_IOCTL_RW(13,  4, s32)
#define	SDI_IOCTL_CH_GRP_1_SRC				OS_IOCTL_RW(14,  4, s32)
#define	SDI_IOCTL_CH_GRP_2_SRC				OS_IOCTL_RW(15,  4, s32)
#define	SDI_IOCTL_CH_GRP_3_SRC				OS_IOCTL_RW(16,  4, s32)
#define	SDI_IOCTL_DATA_FORMAT				OS_IOCTL_RW(17,  4, s32)
#define	SDI_IOCTL_INIT_MODE					OS_IOCTL_RW(18,  4, s32)
#define	SDI_IOCTL_CHANNEL_ORDER				OS_IOCTL_RW(19,  4, s32)
#define	SDI_IOCTL_SW_SYNC					OS_IOCTL   (20)
#define	SDI_IOCTL_SW_SYNC_MODE				OS_IOCTL_RW(21,  4, s32)
#define	SDI_IOCTL_RATE_DIV_00_NDIV			OS_IOCTL_RW(22,  4, s32)
#define	SDI_IOCTL_RATE_DIV_01_NDIV			OS_IOCTL_RW(23,  4, s32)
#define	SDI_IOCTL_RATE_DIV_02_NDIV			OS_IOCTL_RW(24,  4, s32)
#define	SDI_IOCTL_RATE_DIV_03_NDIV			OS_IOCTL_RW(25,  4, s32)
#define	SDI_IOCTL_RATE_DIV_04_NDIV			OS_IOCTL_RW(26,  4, s32)
#define	SDI_IOCTL_RATE_DIV_05_NDIV			OS_IOCTL_RW(27,  4, s32)
#define	SDI_IOCTL_RATE_DIV_06_NDIV			OS_IOCTL_RW(28,  4, s32)
#define	SDI_IOCTL_RATE_DIV_07_NDIV			OS_IOCTL_RW(29,  4, s32)
#define	SDI_IOCTL_RATE_DIV_08_NDIV			OS_IOCTL_RW(30,  4, s32)
#define	SDI_IOCTL_RATE_DIV_09_NDIV			OS_IOCTL_RW(31,  4, s32)
#define	SDI_IOCTL_RATE_DIV_10_NDIV			OS_IOCTL_RW(32,  4, s32)
#define	SDI_IOCTL_RATE_DIV_11_NDIV			OS_IOCTL_RW(33,  4, s32)
#define	SDI_IOCTL_RATE_DIV_12_NDIV			OS_IOCTL_RW(34,  4, s32)
#define	SDI_IOCTL_RATE_DIV_13_NDIV			OS_IOCTL_RW(35,  4, s32)
#define	SDI_IOCTL_RATE_DIV_14_NDIV			OS_IOCTL_RW(36,  4, s32)
#define	SDI_IOCTL_RATE_DIV_15_NDIV			OS_IOCTL_RW(37,  4, s32)
#define	SDI_IOCTL_RATE_GEN_A_NRATE			OS_IOCTL_RW(38,  4, s32)
#define	SDI_IOCTL_RATE_GEN_B_NRATE			OS_IOCTL_RW(39,  4, s32)
#define	SDI_IOCTL_RATE_GEN_C_NRATE			OS_IOCTL_RW(40,  4, s32)
#define	SDI_IOCTL_RATE_GEN_D_NRATE			OS_IOCTL_RW(41,  4, s32)
#define	SDI_IOCTL_RX_IO_ABORT				OS_IOCTL_R (42,  4, s32)
#define	SDI_IOCTL_IRQ_SEL					OS_IOCTL_RW(43,  4, s32)
#define	SDI_IOCTL_WAIT_EVENT				OS_IOCTL_RW(44, 28, gsc_wait_t)
#define	SDI_IOCTL_WAIT_CANCEL				OS_IOCTL_RW(45, 28, gsc_wait_t)
#define	SDI_IOCTL_WAIT_STATUS				OS_IOCTL_RW(46, 28, gsc_wait_t)
#define	SDI_IOCTL_AUTO_CAL_STATUS			OS_IOCTL_R (47,  4, s32)
#define	SDI_IOCTL_CHANNELS_READY			OS_IOCTL_RW(48,  4, s32)
#define	SDI_IOCTL_AIN_BUF_THRESH_STS		OS_IOCTL_R (49,  4, s32)



//*****************************************************************************
// SDI_IOCTL_REG_READ
// SDI_IOCTL_REG_WRITE
// SDI_IOCTL_REG_MOD
//
#define	SDI_REG_ENCODE(s,o)					GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	SDI_GSC_BCR							SDI_REG_ENCODE(4,0x00)// Board Control Register
#define	SDI_GSC_RCAR						SDI_REG_ENCODE(4,0x04)// Rate Control A Register
#define	SDI_GSC_RCBR						SDI_REG_ENCODE(4,0x08)// Rate Control B Register
#define	SDI_GSC_RCCR						SDI_REG_ENCODE(4,0x0C)// Rate Control C Register
#define	SDI_GSC_RCDR						SDI_REG_ENCODE(4,0x10)// Rate Control D Register
#define	SDI_GSC_RAR							SDI_REG_ENCODE(4,0x14)// Rate Assignments Register
#define	SDI_GSC_RD01R						SDI_REG_ENCODE(4,0x18)// Rate Divisor 00/01 Register
#define	SDI_GSC_RD23R						SDI_REG_ENCODE(4,0x1C)// Rate Divisor 02/03 Register
#define	SDI_GSC_RD45R						SDI_REG_ENCODE(4,0x20)// Rate Divisor 04/05 Register
#define	SDI_GSC_RD67R						SDI_REG_ENCODE(4,0x24)// Rate Divisor 06/07 Register
#define	SDI_GSC_RD89R						SDI_REG_ENCODE(4,0x28)// Rate Divisor 08/09 Register
#define	SDI_GSC_RDABR						SDI_REG_ENCODE(4,0x2C)// Rate Divisor 10/11 Register
#define	SDI_GSC_RDCDR						SDI_REG_ENCODE(4,0x30)// Rate Divisor 12/13 Register
#define	SDI_GSC_RDEFR						SDI_REG_ENCODE(4,0x34)// Rate Divisor 14/15 Register
#define	SDI_GSC_BTR							SDI_REG_ENCODE(4,0x38)// Buffer Threshold Register
#define	SDI_GSC_BRR							SDI_REG_ENCODE(4,0x3C)// Board Revision Register
#define	SDI_GSC_BSR							SDI_REG_ENCODE(4,0x40)// Buffer Size Register
#define	SDI_GSC_ACVR						SDI_REG_ENCODE(4,0x44)// Auto-Cal Values Register
#define	SDI_GSC_IDBR						SDI_REG_ENCODE(4,0x48)// Input Data Buffer Register

//*****************************************************************************
// SDI_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.
typedef enum
{
	SDI_QUERY_AUTO_CAL_MS,		// Max auto-cal period in ms.
	SDI_QUERY_CHANNEL_D16,		// Channel count for BRR.D16
	SDI_QUERY_CHANNEL_D17,		// Channel count for BRR.D17
	SDI_QUERY_CHANNEL_GPS,		// Number of channel groups.
	SDI_QUERY_CHANNEL_MAX,		// Maximum number of channels supported.
	SDI_QUERY_CHANNEL_QTY,		// The number of A/D channels.
	SDI_QUERY_COUNT,			// Number of query options.
	SDI_QUERY_DEVICE_TYPE,		// Value from gsc_dev_type_t
	SDI_QUERY_DMDMA,			// Is DMDMA supported?
	SDI_QUERY_FGEN_MAX,			// Rate Generator maximum output rate.
	SDI_QUERY_FGEN_MIN,			// Rate Generator minimum output rate.
	SDI_QUERY_FIFO_SIZE,		// FIFO depth in 32-bit samples
	SDI_QUERY_FSAMP_MAX,		// The maximum sample rate.
	SDI_QUERY_FSAMP_MIN,		// The minimum sample rate.
	SDI_QUERY_INIT_MS,			// Max initialize period in ms.
	SDI_QUERY_NDIV_MASK,		// Mask of valid Ndiv bits.
	SDI_QUERY_NDIV_MAX,			// Maximum rate divisor Ndiv value.
	SDI_QUERY_NDIV_MIN,			// Maximum rate divisor Ndiv value.
	SDI_QUERY_NRATE_MASK,		// Mask of valid Nrate bits.
	SDI_QUERY_NRATE_MAX,		// Maximum rate generator Nrate value.
	SDI_QUERY_NRATE_MIN,		// Maximum rate generator Nrate value.
	SDI_QUERY_RATE_GEN_QTY,		// Number of Rate Generatorts.
	SDI_QUERY_THRESHOLD_MASK,	// Input Buffer Threshold mask
	SDI_QUERY_FORM_FACTOR,		// PCI, PMC ...
	SDI_QUERY_IRQ_MASK			// A 1 for each supported IRQ option.
} sdi_query_t;

#define	SDI_IOCTL_QUERY_LAST				SDI_QUERY_IRQ_MASK
#define	SDI_IOCTL_QUERY_ERROR				(-1)	// A query request is unknown.

// SDI_QUERY_FORM_FACTOR
typedef enum
{
	SDI_FORM_FACTOR_UNKNOWN	= -1,
	SDI_FORM_FACTOR_PCI		= 1,
	SDI_FORM_FACTOR_PMC		= 2,
	SDI_FORM_FACTOR_CPCI	= 3,
	SDI_FORM_FACTOR_PC104P	= 4
} sdi_form_factor_t;


//*****************************************************************************
// SDI_IOCTL_INITIALIZE						BCR D15
//
//	Parameter:	None

//*****************************************************************************
// SDI_IOCTL_AUTO_CALIBRATE					BCR D7
//
//	Parameter:	None

//*****************************************************************************
// SDI_IOCTL_RX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	SDI_IO_MODE_DEFAULT					GSC_IO_MODE_PIO

//*****************************************************************************
// SDI_IOCTL_RX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	SDI_IO_TIMEOUT_DEFAULT				10
#define	SDI_IO_TIMEOUT_NO_SLEEP				0		// Do not sleep to wait for more data.
#define	SDI_IO_TIMEOUT_MIN					0
#define	SDI_IO_TIMEOUT_MAX					GSC_IO_TIMEOUT_MAX
#define	SDI_IO_TIMEOUT_INFINITE				GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// SDI_IOCTL_AIN_BUF_CLEAR					BTR D19
//
//	Parameter:	None.

//*****************************************************************************
// SDI_IOCTL_AIN_BUF_INPUT					BTR D18
//
//	Parameter:	s32
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	SDI_AIN_BUF_INPUT_DISABLE			0	// Disable input to the buffer
#define	SDI_AIN_BUF_INPUT_ENABLE			1	// Enable input to the buffer

//*****************************************************************************
// SDI_IOCTL_AIN_BUF_THRESH					BTR D0-D17
//
//	Parameter:	s32
//		Pass in any valid threshold level, or
//		-1 to read the current setting.
//		The upper limit to the threshold value varies among models.
//		At present it is either 0xFFFF or 0x3FFFF.

//*****************************************************************************
// SDI_IOCTL_AIN_MODE						BCR D0-D1
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_AIN_MODE_DIFF					0	// Differential
#define	SDI_AIN_MODE_SE						1	// Single Ended
#define	SDI_AIN_MODE_ZERO					2	// Zero test
#define	SDI_AIN_MODE_VREF					3	// Vref test

//*****************************************************************************
// SDI_IOCTL_AIN_RANGE						BCR D2-D3
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_AIN_RANGE_1_25V					0	// +- 1.25 volts
#define	SDI_AIN_RANGE_2_5V					1	// +- 2.5 volts
#define	SDI_AIN_RANGE_5V					2	// +- 5 volts
#define	SDI_AIN_RANGE_10V					3	// +- 10 volts

//*****************************************************************************
// SDI_IOCTL_CH_GRP_0_SRC					RAR D0-D3
// SDI_IOCTL_CH_GRP_1_SRC					RAR D4-D7
// SDI_IOCTL_CH_GRP_2_SRC					RAR D8-D11	when supported
// SDI_IOCTL_CH_GRP_3_SRC					RAR D12-D15	when supported.
//
//	Parameter:	s32
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	SDI_CH_GRP_SRC_GEN_A				0
#define	SDI_CH_GRP_SRC_GEN_B				1
#define	SDI_CH_GRP_SRC_GEN_C				2	// Valid if this rate generator is supported.
#define	SDI_CH_GRP_SRC_GEN_D				3	// Valid if this rate generator is supported.
#define	SDI_CH_GRP_SRC_EXTERN				4
#define	SDI_CH_GRP_SRC_DISABLE				5

//*****************************************************************************
// SDI_IOCTL_DATA_FORMAT					BCR D4
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_DATA_FORMAT_2S_COMP				0	// Twos Compliment
#define	SDI_DATA_FORMAT_OFF_BIN				1	// Offset Binary

//*****************************************************************************
// SDI_IOCTL_INIT_MODE						BCR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_INIT_MODE_TARGET				0	// Target
#define	SDI_INIT_MODE_INITIATOR				1	// Initiator

//*****************************************************************************
// SDI_IOCTL_CHANNEL_ORDER					BCR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_CHANNEL_ORDER_ASYNC				0	// Asynchronous channel order
#define	SDI_CHANNEL_ORDER_SYNC				1	// Synchronous channel order

//*****************************************************************************
// SDI_IOCTL_SW_SYNC						BCR D6
//
//	Parameter:	None.

//*****************************************************************************
// SDI_IOCTL_SW_SYNC_MODE					BCR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_SW_SYNC_MODE_SW_SYNC			0	// Perform a Sync operation
#define	SDI_SW_SYNC_MODE_CLR_BUF			1	// Clear the input buffer/

//*****************************************************************************
// SDI_IOCTL_RATE_DIV_00_NDIV				RD01R D0-D5
// SDI_IOCTL_RATE_DIV_01_NDIV				RD01R D8-D13
// SDI_IOCTL_RATE_DIV_02_NDIV				RD23R D0-D5		when supported
// SDI_IOCTL_RATE_DIV_03_NDIV				RD23R D8-D13	when supported
// SDI_IOCTL_RATE_DIV_04_NDIV				RD45R D0-D5		when supported
// SDI_IOCTL_RATE_DIV_05_NDIV				RD45R D8-D13	when supported
// SDI_IOCTL_RATE_DIV_06_NDIV				RD67R D0-D5		when supported
// SDI_IOCTL_RATE_DIV_07_NDIV				RD67R D8-D13	when supported
// SDI_IOCTL_RATE_DIV_08_NDIV				RD89R D0-D5		when supported
// SDI_IOCTL_RATE_DIV_09_NDIV				RD89R D8-D13	when supported
// SDI_IOCTL_RATE_DIV_10_NDIV				RDABR D0-D5		when supported
// SDI_IOCTL_RATE_DIV_11_NDIV				RDABR D8-D13	when supported
// SDI_IOCTL_RATE_DIV_12_NDIV				RDCDR D0-D5		when supported
// SDI_IOCTL_RATE_DIV_13_NDIV				RDCDR D8-D13	when supported
// SDI_IOCTL_RATE_DIV_14_NDIV				RDEFR D0-D5		when supported
// SDI_IOCTL_RATE_DIV_15_NDIV				RDEFR D8-D13	when supported
//
//	Parameter:	s32
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		For some devices the valid range is 1-32.	// For non-HS devices.
//		For some devices the valid range is 0-20.	// For HS devices

//*****************************************************************************
// SDI_IOCTL_RATE_GEN_A_NRATE				RCAR D0-D8
// SDI_IOCTL_RATE_GEN_B_NRATE				RCAR D0-D8
// SDI_IOCTL_RATE_GEN_C_NRATE				RCAR D0-D8	when supported
// SDI_IOCTL_RATE_GEN_D_NRATE				RCAR D0-D8	when supported
//	Parameter:	s32
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		For all devices at this time the valid range is 0-511.

//*****************************************************************************
// SDI_IOCTL_RX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	SDI_IO_ABORT_NO						0
#define	SDI_IO_ABORT_YES					1

//*****************************************************************************
// SDI_IOCTL_IRQ_SEL						BCR D8-D10
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_IRQ_INIT_DONE					0
#define	SDI_IRQ_AUTO_CAL_DONE				1
#define	SDI_IRQ_CHANNELS_READY				2
#define	SDI_IRQ_BUF_THRESH_L2H				3
#define	SDI_IRQ_BUF_THRESH_H2L				4
#define	SDI_IRQ_BUF_AE						5
#define	SDI_IRQ_BUF_AF						6

//*****************************************************************************
// SDI_IOCTL_WAIT_EVENT						all fields must be valid
// SDI_IOCTL_WAIT_CANCEL					fields need not be valid
// SDI_IOCTL_WAIT_STATUS					fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	SDI_WAIT_GSC_INIT_DONE				0x0001
#define	SDI_WAIT_GSC_AUTO_CAL_DONE			0x0002
#define	SDI_WAIT_GSC_CHANNELS_READY			0x0004
#define	SDI_WAIT_GSC_BUF_THRESH_L2H			0x0008
#define	SDI_WAIT_GSC_BUF_THRESH_H2L			0x0010
#define	SDI_WAIT_GSC_BUF_AE					0x0020
#define	SDI_WAIT_GSC_BUF_AF					0x0040
#define	SDI_WAIT_GSC_ALL					0x007F
// gsc_wait_t.alt flags
#define	SDI_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	SDI_WAIT_IO_RX_ABORT				0x0001
#define	SDI_WAIT_IO_RX_DONE					0x0002
#define	SDI_WAIT_IO_RX_ERROR				0x0004
#define	SDI_WAIT_IO_RX_TIMEOUT				0x0008
#define	SDI_WAIT_IO_ALL						0x000F

//*****************************************************************************
// SDI_IOCTL_AUTO_CAL_STATUS				BCR D12
//
//	Parameter:	s32
//		Report the status of the last auto-calibration cycle.
#define	SDI_AUTO_CAL_STATUS_ACTIVE			0
#define	SDI_AUTO_CAL_STATUS_FAIL			1
#define	SDI_AUTO_CAL_STATUS_PASS			2

//*****************************************************************************
// SDI_IOCTL_CHANNELS_READY					BCR D13
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	SDI_CHANNELS_READY_WAIT				1	// Wait upto 1s for the flag to become set
// The following are returned by the driver.
#define	SDI_CHANNELS_READY_NO				0	// The Channels Ready flag is NOT set.
#define	SDI_CHANNELS_READY_YES				1	// The Channels Ready flag IS set.

//*****************************************************************************
// SDI_IOCTL_AIN_BUF_THRESH_STS				BCR D14
//
//	Parameter:	s32
//		One of the following values is returned.
#define	SDI_AIN_BUF_THRESH_STS_CLEAR		0	// Threshold flag is clear.
#define	SDI_AIN_BUF_THRESH_STS_SET			1	// Threshold flag is set.



#endif
