// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 51953 $
// $Date: 2022-10-25 08:37:28 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _voltage_range(void)
{
	gsc_label("Voltage Range");

	// 16SDI
	printf("+-10 V, +-5 V, +-2.5 V, +-1.25 V\n");
	return(0);
}



//*****************************************************************************
static int _channel_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single-Ended, Zero Test, Vref Test\n");

	gsc_label("Input Order");
	printf("Synchronous, Asynchronous\n");
	return(0);
}



//*****************************************************************************
static int _channel_output(void)
{
	gsc_label("Output Channels");
	printf(	"4  (16-bit resolution)\n");
	return(0);
}



//*****************************************************************************
static int _clock_sources(void)
{
	gsc_label("Clock Sources");
	printf("Rate Generators, External\n");
	return(0);
}



//*****************************************************************************
static int _id_device_brr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) sdi_reg_get_def_id(SDI_GSC_BRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, sdi_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. sdi_reg_get_def_id, SDI_GSC_BRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= sdi_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _voltage_range();
	errs	+= _channel_modes();
	errs	+= _channel_output();
	errs	+= _clock_sources();

	for (i = 0; i < SDI_IOCTL_QUERY_LAST; i++)
		errs	+= sdi_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_brr(args);
	errs	+= _register_map(args);

	return(errs);
}


