// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/utils/util_auto_cal_status.c $
// $Rev: 51943 $
// $Date: 2022-10-25 08:29:04 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sdi_auto_cal_status
*
*	Purpose:
*
*		Provide a visual wrapper for the SDI_IOCTL_AUTO_CAL_STATUS service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The status retrieves id recorded here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	sdi_auto_cal_status(int fd, int index, int verbose, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;
	s32		set;

	if (verbose)
		gsc_label_index("Auto-Cal. Status", index);

	ret		= sdi_ioctl(fd, SDI_IOCTL_AUTO_CAL_STATUS, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case SDI_AUTO_CAL_STATUS_ACTIVE:

			strcpy(buf, "Active");
			break;

		case SDI_AUTO_CAL_STATUS_FAIL:

			strcpy(buf, "Fail");
			break;

		case SDI_AUTO_CAL_STATUS_PASS:

			strcpy(buf, "Pass");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}



