// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/utils/util_rate_div_09_ndiv.c $
// $Rev: 51943 $
// $Date: 2022-10-25 08:29:04 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sdi_rate_div_09_ndiv
*
*	Purpose:
*
*		Provide a visual wrapper for the SDI_IOCTL_RATE_DIV_09_NDIV service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sdi_rate_div_09_ndiv(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	s32	qty;
	int	ret;

	if (verbose)
		gsc_label_index("Rate Divisor 9", index);

	errs	= sdi_query(fd, -1, 0, SDI_QUERY_CHANNEL_QTY, &qty);

	if (errs)
	{
		if (verbose)
			printf("FAIL <---  (querry error)\n");
	}
	else if (qty < 10)
	{
		if (verbose)
			printf("SKIPPED  (Channel 9 not supported.)\n");
	}
	else
	{
		ret		= sdi_ioctl(fd, SDI_IOCTL_RATE_DIV_09_NDIV, &set);
		errs	+= ret ? 1 : 0;

		if (verbose)
			printf("%s  (Ndiv = %ld)\n", errs ? "FAIL <---" : "PASS", (long) set);

		if (get)
			get[0]	= set;
	}

	return(errs);
}


