// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/utils/util_rate_gen_nrate.c $
// $Rev: 51943 $
// $Date: 2022-10-25 08:29:04 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Utilities: source file

#include "main.h"




//*****************************************************************************
int	sdi_rate_gen_nrate_all(int fd, int index, int verbose, s32 set)
{
	int	errs;
	s32	qty		= 0;

	errs	= sdi_query(fd, -1, verbose, SDI_QUERY_RATE_GEN_QTY, &qty);

	if (verbose)
		gsc_label_level_inc();

	if (qty > 0)
		errs	+= sdi_rate_gen_a_nrate(fd, index, verbose, set, NULL);

	if (qty > 1)
		errs	+= sdi_rate_gen_b_nrate(fd, index, verbose, set, NULL);

	if (qty > 2)
		errs	+= sdi_rate_gen_c_nrate(fd, index, verbose, set, NULL);

	if (qty > 3)
		errs	+= sdi_rate_gen_d_nrate(fd, index, verbose, set, NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}





//*****************************************************************************
int	sdi_rate_gen_nrate_rate_gen(int fd, int index, int verbose, int rate_gen, s32 set, s32* get)
{
	int	errs;
	s32	qty		= 0;

	errs	= sdi_query(fd, -1, verbose, SDI_QUERY_CHANNEL_GPS, &qty);

	if (errs)
	{
		if (verbose)
			printf(" FAIL <---  (sdi_query() failure)\n");
	}
	else
	{
		if ((rate_gen + 1) <= qty)
		{
			switch (rate_gen)
			{
				case 0: errs	+= sdi_rate_gen_a_nrate(fd, index, verbose, set, get);	break;
				case 1: errs	+= sdi_rate_gen_b_nrate(fd, index, verbose, set, get);	break;
				case 2: errs	+= sdi_rate_gen_c_nrate(fd, index, verbose, set, get);	break;
				case 3: errs	+= sdi_rate_gen_d_nrate(fd, index, verbose, set, get);	break;
			}
		}
		else
		{
			errs++;

			if (verbose)
			{
				printf(" FAIL <---  (invalid rate generator %d, qty %d)\n",
						(int) rate_gen,
						(int) qty);
			}
		}
	}

	return(errs);
}


